        //---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UforCheckIn.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TforCheckIn *forCheckIn;
//---------------------------------------------------------------------------
__fastcall TforCheckIn::TforCheckIn(TComponent* Owner)
        : TForm(Owner)
{

}
//---------------------------------------------------------------------------
void __fastcall TforCheckIn::botBuscarClick(TObject *Sender)
{
        if((ediIdV->Text != "") && (ediIdLoc->Text != ""))
        {
                if(cia->buscaVuelo(StrToInt(ediIdV->Text), pos))
                {
                        tLocalizador loc(StrToInt(ediIdV->Text), StrToInt(ediIdLoc->Text));
                        if(cia->buscaReserva(loc) && !loc.libre())
                        {
                                if(!loc.facturado())
                                {
                                        disponible = dibujar = true;
                                        Repaint();
                                }
                                else ShowMessage("La reserva ya se factur.");
                        }
                        else ShowMessage("No se encontro la reserva.");
                }
                else ShowMessage("No se encontro el vuelo.");
        }
        else ShowMessage("Escriba un vuelo y reserva para continuar.");
}
//---------------------------------------------------------------------------
void __fastcall TforCheckIn::FormPaint(TObject *Sender)
{
        if(dibujar)
        {
                dibujaDist(cia->dameVuelo(pos)->getAvion()->dameDistribucion()); // Distribucion)
        }
}
//---------------------------------------------------------------------------
void __fastcall TforCheckIn::FormMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
        if(disponible)
        {
                if((X > iniX) &&
                   (Y > iniY) &&
                   (X < iniX + (cia->dameVuelo(pos)->getAvion()->dameDistribucion()->getCols() * lado)) &&
                   (Y < iniY + (cia->dameVuelo(pos)->getAvion()->dameDistribucion()->getFils() * lado)))
                {
                        X -= iniX;
                        X /= lado;
                        Y -= iniY;
                        Y /= lado;
                        tLocalizador loc(StrToInt(ediIdV->Text), StrToInt(ediIdLoc->Text), reservado);
                        if(cia->facturar(loc, X, Y))
                        {
                                disponible = false;
                                if(!cia->buscaVuelo(StrToInt(ediIdV->Text), pos))
                                {
                                        dibujar = false;
                                        ShowMessage("Asiento facturado, vuelo cerrado.");
                                }
                                else ShowMessage("Asiento facturado");
                                Repaint();
                        }
                        else
                        {
                                ShowMessage("Asiento no disponible.");
                        }
                }
        }
}
//---------------------------------------------------------------------------

void TforCheckIn::dibujaDist(const matrizBool* dist)
{
        Canvas->Pen->Color = clBlack;
        iniX = (botBuscar->Left + (botBuscar->Width / 2)); // Centramos
        iniX -=  ((dist->getCols() * lado) / 2);
        for(int x1 = 0; x1 < dist->getCols(); x1++)
        {
                for(int y1 = 0; y1 < dist->getFils(); y1++)
                {
                        bool aux;
                        dist->getElem(x1, y1, aux);
                        if(!aux)
                        {
                                Canvas->Brush->Color = clGreen;
                        }
                        else
                        {
                                Canvas->Brush->Color = clRed;
                        }
                        Canvas->Rectangle((x1 * lado) + iniX,
                                          (y1 * lado) + iniY,
                                          ((x1 + 1) * lado) + iniX,
                                          ((y1 + 1) * lado) + iniY);
                }
        }
}

void __fastcall TforCheckIn::FormCreate(TObject *Sender)
{
        iniY = botBuscar->Top + botBuscar->Height + 15;
        disponible = dibujar = false;
        lado = 30;
        pos = 0;
}
//---------------------------------------------------------------------------

void __fastcall TforCheckIn::ediIdVChange(TObject *Sender)
{
        dibujar = disponible = false;
        Repaint();
}
//---------------------------------------------------------------------------

void __fastcall TforCheckIn::ediIdLocChange(TObject *Sender)
{
        dibujar = disponible = false;
        Repaint();
}
//---------------------------------------------------------------------------

