//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UforReservas.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TforReservas *forReservas;
//---------------------------------------------------------------------------
__fastcall TforReservas::TforReservas(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TforReservas::botOkClick(TObject *Sender)
{
        tLocalizador loc;
        if(vuel > 0)
        {
                if(cia->hazReserva(vuel, loc))
                {
                        ShowMessage(loc.LocToStr());
                        ModalResult = mrOk;
                }
                else
                {
                        ShowMessage("No se ha podido realizar la reserva. El vuelo esta completo?");
                }
        }
        else
        {
                ShowMessage("Seleccione un vuelo para hacer la reserva.");
        }
}
//---------------------------------------------------------------------------
void __fastcall TforReservas::botCancelClick(TObject *Sender)
{
        ModalResult = mrCancel;        
}
//---------------------------------------------------------------------------
void __fastcall TforReservas::FormCreate(TObject *Sender)
{
        grid->Cells[0][0] = "Identificador de Vuelo";
        grid->Cells[1][0] = "Hora de Salida";
        grid->Cells[2][0] = "Duracion";
        grid->Cells[3][0] = "Compaia";
        grid->Cells[4][0] = "Precio del Billete";
        grid->Cells[5][0] = "Low Cost";
        vuel = -1;
}
//---------------------------------------------------------------------------
void __fastcall TforReservas::botBuscarClick(TObject *Sender)
{
        bool encontrado = false;
        int j = 1;
        limpiaGrid();
        vuel = -1;
        if((ediOri->Text != "") && (ediDes->Text != ""))
        {
                for(tSize i = 0; i < cia->dameNumVuelos(); i++)
                {
                        if(cia->dameVuelo(i)->mismoItinerario(ediOri->Text.c_str(), ediDes->Text.c_str()))
                        {
                                if(j == grid->RowCount)
                                {
                                        grid->RowCount++;
                                }
                                grid->Cells[0][j] = cia->dameVuelo(i)->getId();
                                grid->Cells[1][j] = IntToStr(cia->dameVuelo(i)->getSalida().dameHoras()) + ":" + IntToStr(cia->dameVuelo(i)->getSalida().dameMinutos());
                                grid->Cells[2][j] = IntToStr(cia->dameVuelo(i)->getDuracion().dameHoras()) + ":" + IntToStr(cia->dameVuelo(i)->getDuracion().dameMinutos());
                                grid->Cells[3][j] = cia->dameVuelo(i)->getCia().data();
                                grid->Cells[4][j] = IntToStr(cia->dameVuelo(i)->getPrecio());
                                if(typeid(*(cia->dameVuelo(i))) == typeid(tVueloBajoCoste))
                                {
                                        grid->Cells[5][j] = "Si";
                                }
                                else
                                {
                                        grid->Cells[5][j] = "No";
                                }
                                j++;
                                encontrado = true;
                        }
                }
        }

        if(!encontrado)
        {
                ShowMessage("Error. No se encontraron vuelos que vayan de " + ediOri->Text + " a " + ediDes->Text);
        }
}
//---------------------------------------------------------------------------
void __fastcall TforReservas::gridSelectCell(TObject *Sender, int ACol,
      int ARow, bool &CanSelect)
{
        if((ACol == 0) && (ARow > 0) && (grid->Cells[ACol][ARow] != ""))
        {
                vuel = StrToInt(grid->Cells[ACol][ARow]);
                ShowMessage("Vuelo " + IntToStr(vuel) + " seleccionado.");
        }
}
//---------------------------------------------------------------------------

void TforReservas::limpiaGrid()
{
        for (int i = 1; (i < grid->RowCount) || ( i < 6); i++)
        {
                grid->Cells[0][i] = "";
                grid->Cells[1][i] = "";
                grid->Cells[2][i] = "";
                grid->Cells[3][i] = "";
                grid->Cells[4][i] = "";
                grid->Cells[5][i] = "";
        }
        grid->RowCount = 6;
}
