//---------------------------------------------------------------------------

#ifndef UtCompanyH
#define UtCompanyH

#include "UtVuelo.h"
#include "UtVueloNormal.h"
#include "UtVueloBajoCoste.h"
#include "UtListaOrd.h"

//---------------------------------------------------------------------------

const MAX_VUELOS = 100;
typedef unsigned int tSize;

bool menorId(tVuelo* a, tVuelo* b)
{
        return (*a < *b);
}

typedef ListaOrd<tVuelo*, menorId> ListaVuelos;

class tCompany
{
public:
        tCompany() {numVuelos = 0;};
        ~tCompany();
        tSize dameNumVuelos() {return numVuelos;};
        const tVuelo* dameVuelo(tSize i) { if(i < MAX_VUELOS) {return vuelos.at(i);} else {return NULL;}};
        bool insertaVuelo(tipoVuelo tv, const string& o, const string& d, const tHora& hs, const tHora& dur, const string& co, int IdV, int pre);
        bool eliminaVuelo(int idVuelo);
        bool hazReserva(int idVuelo, tLocalizador& loc);
        bool eliminaReserva(const tLocalizador& loc);
        virtual bool salvar(const string& nomb) const;
        virtual bool cargar(const string& nomb);

        bool buscaVuelo(int idVuelo, tSize& pos);
        bool buscaReserva(tLocalizador& loc);
        bool facturar(tLocalizador& loc, tSize col, tSize fil);

private:
        int numVuelos;
        //tVuelo* vuelos[MAX_VUELOS];
        ListaVuelos vuelos;
        bool buscaVuelo(int idVuelo, tSize& pos, tSize ini, tSize fin);
};

#endif
