//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UtLocalizador.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

tLocalizador::tLocalizador(int iv, int ia, estadoLoc est)
{
        idVuelo = iv;
        idLocalizador = ia;
        estado = est;
}

AnsiString tLocalizador::LocToStr()
{
        AnsiString aux = "Localizador numero ";
        aux += idLocalizador;
        aux += " para el vuelo ";
        aux += idVuelo;
        aux += " con estado ";
        switch (estado)
        {
                case vacio:
                        aux += "libre.";
                break;
                case reservado:
                        aux += "reservado.";
                break;
                case esperar:
                        aux += "esperando.";
                break;
                case facturad:
                        aux += "facturado.";
                break;
                default:
                        aux += "erroneo.";
                break;
        }
        return aux;
}
bool tLocalizador::salvar(ofstream& sal) const
{
        sal.write((char*)& idVuelo, sizeof(int));
        sal.write((char*)& idLocalizador, sizeof(int));
        sal.write((char*)& estado, sizeof(estadoLoc));
        return sal;
}

bool tLocalizador::cargar(ifstream& ent)
{
        ent.read((char*)& idVuelo, sizeof(int));
        ent.read((char*)& idLocalizador, sizeof(int));
        ent.read((char*)& estado, sizeof(estadoLoc));
        return ent;
}

tLocalizador tLocalizador::operator=(const tLocalizador& loc)
{
        idVuelo = loc.idVuelo;
        idLocalizador = loc.idLocalizador;
        estado = loc.estado;
        return *this;
}

