//---------------------------------------------------------------------------

#ifndef UtVueloH
#define UtVueloH

#include "UtHora.h"
#include "UtLocalizador.h"
#include "UtAvion.h"
#include "UtLista.h"

//---------------------------------------------------------------------------

enum tipoVuelo {normal, bajoCoste};

typedef unsigned int tSize;

class tVuelo
{
public:
        tVuelo() {avion = NULL;};
        tVuelo(const string& or, const string& des, const tHora& hs, const tHora& dur, const string& com, int idV, int pre);
        virtual ~tVuelo();
        bool setAvion(tAvion* av);
        int getId() const {return IdVuelo;};
        int getPrecio() const {return precioBillete;};
        tHora getSalida() const {return horaSalida;};
        tHora getDuracion() const {return duracion;};
        string getOrigen() const {return origen;};
        string getDestino() const {return destino;};
        string getCia() const {return company;};
        const tAvion* getAvion() const {return avion;};
        virtual bool hazReserva(tLocalizador&) = 0;
        virtual bool eliminaReserva(const tLocalizador& loc) = 0;
        bool mismoItinerario(const string& origen, const string& destino) const {return (this->origen == origen) && (this->destino == destino) ;};
        virtual bool salvar(ofstream& sal) const;
        virtual bool cargar(ifstream& ent);

        bool cerrado()const;
        bool buscaReserva(int idLoc, tLocalizador& l)const;
        bool facturar(tLocalizador& loc, tSize col, tSize fil);
        bool operator<(const tVuelo& v) {return IdVuelo < v.IdVuelo;};
        bool operator==(const tVuelo& v) {return IdVuelo == v.IdVuelo;};

protected:
        string origen;
        string destino;
        tHora horaSalida;
        tHora duracion;
        tAvion* avion; // utilizado en la clase tVueloBajoCoste
        string company;
        int IdVuelo; // utilizado en la clase tVueloBajoCoste
        int precioBillete;
        Lista<tLocalizador> localizadores; // utilizado en la clase tVueloBajoCoste

        virtual bool buscaLoc(int idLoc, int & pos, int ini, int fin)const; // auxiliar
};

#endif
