//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UtVueloBajoCoste.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

bool tVueloBajoCoste::hazReserva(tLocalizador& loc)
{
        if(getAvion()->dameAsientosOcupados() < getAvion()->dameCapacidad())
        {
                tLocalizador loca(IdVuelo, idLoc++, reservado);
                localizadores.push_back(loca);
                loc = loca;
                avion->reservaAsiento();
                return true;
        }
        else
        {
                tLocalizador loca(IdVuelo, idLoc++, esperar);
                cola.push(loca);
                loc = loca;
                return true;
        }
}

bool tVueloBajoCoste::eliminaReserva(const tLocalizador& loc)
{
        unsigned int i = 0;
        while(i < getAvion()->dameCapacidad() &&
              localizadores.at(i).dameIdLocalizador() != loc.dameIdLocalizador())
        {
                i++;
        }
        if(i < getAvion()->dameCapacidad())
        {
                tLocalizador loca;
                if(cola.front(loca))
                {
                        cola.pop();
                        loca.reservar();
                        localizadores.at(i) = loca;
                }
                else
                {
                        localizadores.erase(i);
                        avion->eliminaAsiento();
                }
                return true;
        }
        else return false;
}
        // operaciones con ficheros
bool tVueloBajoCoste::salvar(ofstream& sal) const
{
        tipoVuelo tv = bajoCoste;
        sal.write((char *)& tv, sizeof(tipoVuelo));
        tVuelo::salvar(sal);
        unsigned int aux = cola.size();
        sal.write((char*)& aux , sizeof(unsigned int));
        if(cola.iniciaIter())
        {
                cola.actualIter().salvar(sal);
                while(cola.avanzaIter())
                {
                        cola.actualIter().salvar(sal);
                }
        }
        return sal;
}

bool tVueloBajoCoste::cargar(ifstream& ent)
{
        tVuelo::cargar(ent);
        cola.clear();
        unsigned int listcont;
        ent.read((char*)& listcont, sizeof(unsigned int));
        if(listcont > 0)
        {
                tLocalizador aux;
                while(listcont != cola.size())
                {
                        aux.cargar(ent);
                        cola.push(aux);
                }
        }

        return ent;
}
